/**
 * Author: qiuxiaoqiang@xunlei.com
 * Date  : 2015-03-12
 * Time  : 10:00
 * Describe:
 */
/*global define:false*/
    var temp = {
        downLoadList: function (data) {
            var html = '';
            $.each(data.taskInfos, function (i, val) {
                html += '<li>' +
                      '<a class="user_item_list_a js_localPlay" from="download" filename="' + val.fileName + '" id="' + val.taskId + '" path="' + val.filePath + '" href="javascript:;">' +
                          '<div class="uil_wbox">' +
                              '<h4>' + val.fileName + '</h4>' +
                          '</div>' +
                          '<div class="user_item_abs">已完成</div>' +
                      '</a>' +
                  '</li>';
            });
            return html;
        },
        playRecordList: function (data) {
            var html = '';
            $.each(data.vodInfos, function (i, val) {
                if (val.type === 'yunbo') {
                    html += '<li>' +
                          '<a class="user_item_list_a js_yunbo" href="javascript:;" data-title="' + val.title + '" data-url="' + val.url + '" data-gcid="' + val.gcid + '" data-cid="' + val.cid + '" data-fileSize="' + val.fileSize + '">' +
                              '<div class="uil_wbox">' +
                                  '<h4>' + val.title + '</h4>' +
                              '</div>' +
                          '</a>' +
                      '</li> ';
                } else if (val.type === 'online') {
                    html += '<li>' +
                          '<a class="user_item_list_a js_online" href="javascript:;" data-title="' + val.title + '" data-tag="' + val.tag + '" data-md5="' + val.ref_id + '" data-ref="' + (val.ref_url).replace(/\"/g, '\'') + '">' +
                              '<div class="uil_wbox">' +
                                  '<h4>' + val.title + '</h4>' +
                                  '<p>上次观看至<em>' + val.playedTime + '</em></p>' +
                              '</div>' +
                          '</a>' +
                      '</li> ';
                } else {
                    html += '<li>' +
                          '<a class="user_item_list_a js_localPlay" from="record" href="javascript:;" filename="" path="' + val.url + '">' +
                              '<div class="uil_wbox">' +
                                  '<h4>' + val.title + '</h4>' +
                                  '<p>上次观看至<em>' + val.playedTime + '</em></p>' +
                              '</div>' +
                          '</a>' +
                      '</li> ';
                }
            });
            return html;
        }
    }

    var Page = {
        initialize: function () {
            var self = this;
            var VIPactInfo = {};
            var callBackMethod = {};
            callBackMethod.loginCallBack = function () {
                self.getLoginStatus();
                self.userStatus();
                self.setMemberCenter();
                //self.setVipTip();
            }
            callBackMethod.getPlayRecord = function (json) {
                self.getPlayRecordList(json);
            }
            callBackMethod.upDatePlayRecord = function () {
                self.getPlayRecordList();
            }
            callBackMethod.upDateDownloadList = function () {
                self.getDownloadFinishedTasks();
            }
            window.callBackMethod = callBackMethod;

            this.getLoginStatus();
            this.userStatus();
            this.events();
            this.setVipTip();
            this.getDownloadFinishedTasks();
            this.getPlayRecordList();
            self.setXLBird();
            this.setMoreBanIcon();
            this.setMemberCenter();
            this.setQuickPay();
            this.setIconBanner();

            //vip红点
            //this.setVipMark();
        },
        requestData: function (json) {
            //json.api = util.addSign(json.api);
            util.showLoadingView();
            $.ajax({
                url: json.api,
                type: 'get',
                dataType: json.dataType,
                timeout: 5000,
                success: function (data) {
                    util.hideLoadingView();
                    json.callback(data);
                },
                error: function (xhr, errorType, error) {
                    //util.showToast(errorType + '点击有点频繁，请重新刷新页面!');
                    if (!navigator.onLine || errorType === 'timeout' ) {
                        // util.showToast('网络连接有问题，请检查网络' + json.pos);
                    }
                }
            });
        },
        events: function () {
            var self = this;
            $('.js_vipinfo').on('click', function () {
                var val = $(this),
                    json = {};
                util.reportUmeng({
                    actionId: 50016,
                    action: 'vip',
                    pos: 'iconBanner'
                });
                $('.uico_dot').hide();
                json['vipMarkTimeLast' + self.getUserId()] = util.getValueFromKeyString('vipMarkTime' + self.getUserId());
                json['vipMarkTime' + self.getUserId()] = Math.round(new Date().getTime() / 1000);
                util.saveKeyValueString(json);
                util.goToActivityPaymentWay();
            });
            $('.js_btn_pay').on('click', function () {
                var val = $(this),
                    action = 'quickRecharge';
                if(val.hasClass('js_isQuickNew')) {
                    action = 'quickNew';
                }
                util.reportUmeng({
                    actionId: 50016,
                    action: action
                });
                if(action=='quickRecharge') {
                    util.goToActivityPaymentWayWithParam({"operType":2,"refer":'v_an_shoulei_grzx_xf_fast'});
                } else {
                    util.goToActivityPaymentWayWithParam({"operType":0,"refer":'v_an_shoulei_grzx_kt_fast'});
                }
            });
            $('.js_shoplink').on('click', function () {
                var val = $(this);
                util.reportUmeng({
                    actionId: 50016,
                    action: 'integral'
                });
                util.openDetailPage('http://m.sjzhushou.com/scoremall/index.html');
            });
            $('.js_memberCenterLink').on('click', function() {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'vip',
                    pos: 'newBanner'
                });
                util.openDetailPage(VIPactInfo[0].url);
            });
            $('.js_setting').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'setting_more'
                });
                util.goToActivitySettingsIndex();
            });
            $('.js_unfinished_task_link').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'task'
                });
                util.goToTaskActivity();
            });

            $('.js_playRecord_more').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'record_more'
                });
                util.goToCloudPlayRecord();
            });
            $('.js_downloadCenter_more').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'download_more'
                });
                util.goToDownloadList();
            });
            $('.js_remoteDownload').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'remotedownload'
                });
                util.goToRemoteDownload();
            });
            $('.js_savePath').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'savepath'
                });
                util.goToSelectSavePath();
            });
            $('.js_downloadSetting').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'downloadsetting'
                });
                util.goToDownloadSetting();
            });
            $('.js_xlbird').on('click', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'xlbird'
                });
                $(this).find('.uico_dot').hide();
                util.gotoKuaiNiao();
            });
            $('.js_timecloud').on('click', function () {
                var packageName = 'com.xunlei.timealbum';
                if(util.isInstalledApk(packageName)) {
                    util.inStallTalbumApk('');
                } else {
                    util.showToast('暂未安装下载宝');
                }
            });

            $('body').on('click', '.js_do_today_sign', function () {
                self.doTodaySign();
            });
            $('body').on('click', '.js_gift', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'gift'
                });
                util.openDetailPage('http://m.sjzhushou.com/scoremall/gamegift/index.html');
            });
            $('body').on('click', '.js_localPlay', function () {
                var val = $(this),
                    action = 'record_list';

                if (val.attr('from') === 'download') {
                    action = 'download_list';
                }
                util.reportUmeng({
                    actionId: 50016,
                    action: action
                });

                util.vodFromLocal(val.attr('path') + val.attr('filename'));
            });
            $('body').on('click', '.js_yunbo', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'record_list'
                });

                var val = $(this),
                    json = {
                        type: "yunbo",
                        title: val.data('title'),
                        gcid: val.data('gcid'),
                        cid: val.data('cid'),
                        fileSize: val.data('fileSize'),
                        url: val.data('url')
                    };
                util.vodYunbo(json);
            });
            $('body').on('click', '.js_online', function () {
                util.reportUmeng({
                    actionId: 50016,
                    action: 'record_list'
                });

                var val = $(this),
                    json = {
                        tag: val.data('tag'),
                        id: val.data('md5'),
                        ref: val.data('ref')
                    };

                popup(json);
            });
        },
        getUserId: function () {
            var uid;
            try {
                uid = window.share.getUserId();
            } catch (e) {
                uid = util.getUriValue('userid') || '';
            }
            return uid;
        },
        getLoginStatus: function () {
            if (util.getUserId()=='') {
                this.isLogin = false;
            } else {
                this.isLogin = true;
            }
        },
        userStatus: function () {
            if (this.isLogin) {
                $('.user_top_new_unlogin').hide();
                $('.user_top_new_logined').show();
                $('.user_name').find('em').text(util.getUserName());
                $('.headpic').removeClass('headpic_default');
                //设置用户缓存头像
                if(!!localStorage.getItem("storageImage")){
                    var storageImage = localStorage.getItem("storageImage");
                    $('.portaitpath').attr("src", storageImage);
                }else{
                    $('.portaitpath').attr('src', 'images/user/100x100.jpg');
                }
                if (util.isVip() == '1') {
                    $('.ico_vip').removeClass('disabled');
                    var expireDate = util.getMemberExpireDate();
                    $('.user_top_info').show().text('有效期 ' + expireDate.substr(0, 4) + '-' + expireDate.substr(4, 2) + '-' + expireDate.substr(6, 2));
                } else {
                    $('.ico_vip').addClass('disabled js_vipinfo');
                }
                // $('.headpic').off();
                $('.headpic').on('click', function (e) {
                    util.showToast('网络连接有问题，请检查网络');
                });
                //$('.user_do').show();
                this.task();
                this.task_getUserCounts();
            } else {
                $('.user_top_new_logined').hide();
                $('.user_top_new_unlogin').show();
                $('.uico_dot').hide();
                $('.headpic, .btn_login_new').off();
                //$('.user_do').hide();
                $('.headpic').addClass('headpic_default');
                $('.portaitpath').attr('src', 'img/headpic.jpg');
                //$('.ico_vip').addClass('disabled');
                //$('.user_top_info').text('').hide();

                $('.headpic, .btn_login_new').on('click', function () {
                    util.goToLoginPageAndCallback({
                        callback: 'window.callBackMethod.loginCallBack'
                    });
                });
            }
        },
        getToday: function (n) {
            var timesObj = {},
                now = new Date(),
                y = now.getFullYear(),
                m = (now.getMonth() + 1) > 9 ? (now.getMonth() + 1) : ('0' + (now.getMonth() + 1)),
                d = now.getDate() > 9 ? now.getDate() : '0' + now.getDate();
            timesObj.y = y;
            timesObj.m = m;
            timesObj.d = d;
            return timesObj[n] ? timesObj[n] : (y + m + d);
        },
        setVipMark: function () {
            var json = {},
                self = this,
                morningTime = new Date(Date.UTC(self.getToday('y'), self.getToday('m') - 1, self.getToday('d'), 0, 0, 0)),
                morningTimeStamp = parseInt(morningTime.getTime() / 1000 - 8 * 60 * 60),
                curTime = Math.round(new Date().getTime() / 1000);

            if (!util.getValueFromKeyString('vipMarkTime' + self.getUserId())) {
                json['vipMarkTime' + self.getUserId()] = curTime;
                json['vipMarkTimeLast' + self.getUserId()] = 0;
                util.saveKeyValueString(json);
            }
            if (util.getValueFromKeyString('vipMarkTimeLast' + self.getUserId()) > morningTimeStamp) {
                $('.uico_dot').hide();
            } else {
                $('.uico_dot').show();
            }
        },
        getSignStatus: function (data) {
            var signStatus = data.todaySign,
                signDay = data.info.sign.day;
            this.signDay = (signDay>7 ? 7 : signDay);
            if (signStatus == 0) {
                $('.btn_signin').addClass('js_do_today_sign');
            } else {
                $('.btn_signin').html('已签到 <em class="sign_day">' + signDay + '</em>/7天').addClass('btn_signin_done disabled');
            }
        },
        doTodaySign: function () {
            var that = this,
                url = 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_b_sign?userId=' + util.userId + '&type=0&peerId=' + util.peerId + '&_t=' + new Date().getTime();
            // TODO: replace API and change to post
            util.showLoadingView();
            //url = util.addSign(url);
            $.ajax({
                url: url,
                type: 'get',
                dataType: 'jsonp',
                timeout: 5000,
                success: function (json) {
                    util.hideLoadingView();
                    var signDay = parseInt(that.signDay) + 1,
                        counts = parseInt(json.counts);
                    signDay = (signDay>7 ? 7 : signDay);
                    if (json.code === '0') {
                        $('.btn_signin').addClass('btn_signin_done disabled').removeClass('js_do_today_sign').html('已签到 <em class="sign_day">' + signDay + '</em>/7天');
                        if (signDay === 7) {
                            counts = counts + 20;
                            util.showToast('加' + counts + '积分 /达成7日成就，明天继续');
                        } else {
                            util.showToast('加' + counts + '积分 /7天连续签到有惊喜');
                        }
                        that.task_getUserCounts();
                    } else {
                        // util.showToast(json.msg);
                    }
                },
                error: function (xhr, errorType, error) {
                    util.hideLoadingView();
                    if (!navigator.onLine || errorType == 'timeout' ) {
                        util.goToLoginPageAndCallback({
                            callback: 'window.callBackMethod.loginCallBack'
                        });
                        // util.showToast('网络连接有问题，请检查网络9');
                    } else {
                        // util.showToast('网络连接有问题，请检查网络10');
                    }
                }
            });
        },
        task: function () {
            var self = this,
                json = {
                    api: 'http://jifenshangcheng.m.xunlei.com/cgi-bin/integra_info?userId=' + util.userId + '&peerId=' + util.peerId + '&versionCode=' + util.versionCode() + '&_t=' + new Date().getTime(),
                    dataType: 'jsonp',
                    pos: 2
                };
            var callback = function (data) {
                self.getSignStatus(data);
                if (!data.unfinishTask) {
                    $('.js_unfinished_task_link').find('em').html(':)');
                    $('.js_unfinished_task_link').find('span').text('')
                } else {
                    $('.js_unfinished_task_link').find('em').text(data.unfinishTask);
                }
            }
            json.callback = callback;
            this.requestData(json);
        },
        task_getUserCounts: function () {
            // 外网  http://scoremall.niu.xunlei.com:17016/
            // 内网  http://10.10.9.9:17016/
            var self = this,
                json = {
                    api: 'http://scoremall.niu.xunlei.com:17016/ScoreMall/call?a=getScore&uid=' + util.userId + '&t=' + (+new Date()),
                    dataType: 'jsonp',
                    pos: 5
                };
            var callback = function (data) {
                $('.js_my_count').text(data.data.score);
            }
            json.callback = callback;
            this.requestData(json);
        },
        setVipTip: function() {
            var self = this;
            if(this.isLogin) {
                // 已经登录，判断是否会员
                if (util.isVip() == '1') {
                    // 是会员，判断会员到期日 20150423
                    var expireDate = util.getMemberExpireDate();
                    var dateDiff = parseInt(expireDate) - parseInt(self.getToday());
                    if(dateDiff>3) {
                        $('#vipTip').html('有效期' + expireDate.substr(0, 4) + '-' + expireDate.substr(4, 2) + '-' + expireDate.substr(6, 2));
                    } else {
                        $('#vipTip').css('color', '#ff7a15');
                        $('#vipTip').html('还剩' + dateDiff + '天到期');
                        self.setVipMark();
                    }
                } else {
                    // 不是会员
                    $('#vipTip').html('开通会员飞一般的感觉');
                }
            } else {
                // 未登录
                $('#vipTip').html('');
            }
        },
        getDownloadFinishedTasks: function () {
            var json = util.getDownloadFinishedTasks(2);
            if (typeof json === 'string') {
                json = JSON.parse(json);
            }
            var list = temp.downLoadList(json);

            if (!list) {
                $('.js_downList').html('<li class="user_item_waiting">还没有视频下载完成哦~</li>');
            } else {
                $('.js_downList').html(list);
            }
        },
        getPlayRecordList: function (json) {
            //json = '{"vodInfos": [{"ref_id": "6f10ed0e8dd065c754dbda8ab53fcdbe","title": "高校处世王-10.flv","playedTime": "03:35","type": "online","tag": "soku_tudou","ref_url": "{\\"iid\\":132201931,\\"vcode\\":\\"XNzQxMTk0Mjky\\"}"},{"type": "local","url": "/storage/emulated/0/Android/obb/com.xunlei.downloadprovider/暴疯语.HD1280高清国语中字.mp4","title": "暴疯语.HD1280高清国语中字.mp4","playedTime": "1:35:00"}]}';
            if (!json) {
                util.getPlayRecords(2);
                return;
            }

            if (typeof json === 'string') {
                json = JSON.parse(json);
            }
            var list = temp.playRecordList(json);

            if (!list) {
                $('.js_recordList').html('<li class="user_item_waiting">还没有看过什么东西哦~</li>');
            } else {
                $('.js_recordList').html(list);
            }
        },
        setXLBird: function () {
            $('.xlbird_tip').show();
            $('.speed_ban').show();
            var isFirst = util.inFirstKAccel();
            if (isFirst == 1) {
                $('.uico_xlbird > .uico_dot').show();
            }
        },
        setXLTimecloud: function() {
            if(this.isLogin) {
                // userid、sessionid、bindtype、mbid、v(version)、from(phone)
                var self = this,
                    json = {
                        // http://dm.xiazaibao.xunlei.com/timecloud/user/otherquerydevice?userid=273347711&sessionid=&bindtype=1&mbid=38AA3C804EA4004V&v=10440&from=phone&t=1439362921437&callback=jsonp3
                        api: 'http://dm.xiazaibao.xunlei.com/timecloud/user/otherquerydevice?userid=' + util.userId + '&sessionid=' + util.getSessionId() + '&bindtype=1&mbid=' + util.peerId + '&v=' + util.versionCode() + '&from=phone&t=' + (+new Date()),
                        dataType: 'jsonp',
                        pos: 6
                    };
                var callback = function (data) {
                    if(data.ret==0 && data.devices.length>0) {
                        $('.xlbird_tip').show();
                        $('.js_timecloud').show();
                    } else {
                        console.log('otherquerydevice error or no devices');
                    }
                }
                json.callback = callback;
                this.requestData(json);
            }
        },
        setMoreBanIcon: function() {
            if(util.versionCode()>10430) {
                $('.js_more').removeClass('fico_speedup').addClass('fico_more');
            }
        },
        setMemberCenter: function() {
            var VIPactInfoStr = util.getValueFromKeyString('VIPactInfo');
            // VIPactInfoStr = '[{"id":"1","url":"http:\/\/act.vip.xunlei.com\/vip\/2015\/shoulei\/","viptext":"\u7eed\u8d39\u6709\u793c","normaltext":"\u5f00\u901a\u6709\u793c","nologintext":"\u767b\u5f55\u6709\u793c","img_upload":"http:\/\/img.vip.xunlei.com\/img\/banner\/201509110954194522.png","start_time":1441468800,"end_time":1441987200,"block_detailid":"4014"}]';
            if(VIPactInfoStr!='') {
                VIPactInfo = JSON.parse(VIPactInfoStr);
                var now = parseInt((new Date().getTime()) / 1000);
                if(VIPactInfo[0].start_time<=now && VIPactInfo[0].end_time>=now) {
                    if(this.isLogin) {
                        if(util.isVip() == '1') {
                            $('.js_memberCenterText').html(VIPactInfo[0].viptext);
                        } else {
                            $('.js_memberCenterText').html(VIPactInfo[0].normaltext);
                        }
                    } else {
                        $('.js_memberCenterText').html(VIPactInfo[0].nologintext);
                    }
                    $('.js_memberCenterIcon').css("background-image","url(images/user/user/ico_gift.png)");
                } else {
                    $('.js_memberCenterIcon').css("background","url()");
                }
                $('.js_memberCenter').show();
                var dot = util.getValueFromKeyString('memberCenterId');
                if(dot!=VIPactInfo[0].id) {
                    $('.js_memberCenterIcon').html('<i class="uico_dot"></i>');
                    util.saveKeyValueString({'memberCenterId': VIPactInfo[0].id});
                }
            }
        },
        setQuickPay: function() {
            if(util.versionCode()>=10460) {
                if(this.isLogin && util.isVip()=='1') {
                    $('.js_btn_pay').removeClass('js_isQuickNew').addClass('js_isQuickRecharge').html('快速续费');
                }
                $('.js_btn_pay').show();
            }
        },
        setIconBanner: function() {
            if(util.versionCode()<10460) {
                $('.user_do_new .user_do_item').css('width', '25%');
            }
        }
    }

    /**
     * 切换模式显示
     * @param  {int} status     切换状态。0白天，1夜间
     * @return {[type]}         [description]
     */
    window.switchNightModeCallback = function(status) {
        if(status==1) {
            // 白天
            $('.user_top_model').removeClass('day').addClass('night');
            $('.user_top_model').html('<a href="#" class="btn_switch"><span class="uico"></span>日间模式</a>');
        } else {
            // 夜间
            $('.user_top_model').removeClass('night').addClass('day');
            $('.user_top_model').html('<a href="#" class="btn_switch"><span class="uico"></span>夜间模式</a>');
        }
    }

    $(function () {
        util.reportUmeng({
            actionId: 50015,
            action: 'view'
        });
        Page.initialize();

        $('.user_top_model').bind('click', function() {
            util.reportUmeng({
                actionId: 50016,
                action: 'switchnightmode'
            });
            util.switchNightMode();
        });
        switchNightModeCallback(util.isNightMode());
        $('.user_top_model').show();
    });


